SystemOrganization addCategory: #MethodConverters!

Object subclass: #AbstractMethodConverter
	instanceVariableNames: 'shouldShout method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodConverters'!

!AbstractMethodConverter commentStamp: '<historical>' prior: 0!
An AbstractMessageConverter is a wrapper used to switch which information to retrieve from a method.

This way, you can avoid switch case, you just have to use set the correct filter!

!AbstractMethodConverter class methodsFor: 'instance creation' stamp: ''!
method: aMessage

	^ self new
		method: aMessage;
		yourself! !

!AbstractMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
getText

	method ifNil: [ ^ '' ].	
	^ self internalGetText! !

!AbstractMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
getTextFor: aMethod

	method := aMethod.
	method ifNil: [ ^ '' ].
	
	^ self internalGetText! !

!AbstractMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 2/10/2012 09:23'!
internalGetText

	^ self subclassResponsibility! !

!AbstractMethodConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
method

	^ method! !

!AbstractMethodConverter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
method: aMessage

	method := aMessage! !

!AbstractMethodConverter methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/16/2012 01:19'!
shouldShout

	^ false! !

AbstractMethodConverter subclass: #ByteCodeMethodConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodConverters'!

!ByteCodeMethodConverter commentStamp: '<historical>' prior: 0!
A ByteCodeMessageConverter is a wrapper wich display the bytecode of the provided message!

!ByteCodeMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
internalGetText

	^ method symbolic asText! !

AbstractMethodConverter subclass: #DecompileMethodConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodConverters'!

!DecompileMethodConverter commentStamp: '<historical>' prior: 0!
A DecompileMessageConverter is a wrapper wich display the decompile source code of the provided message!

!DecompileMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
internalGetText

	^ method method decompileWithTemps decompileString asText makeSelectorBoldIn: method methodClass! !

!DecompileMethodConverter methodsFor: 'as yet unclassified' stamp: ''!
shouldShout

	^ true.! !

AbstractMethodConverter subclass: #SourceMethodConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodConverters'!

!SourceMethodConverter commentStamp: '<historical>' prior: 0!
A SourceMessageConverter is a wrapper wich display the source code of the provided message!

!SourceMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 04:12'!
internalGetText

	^ method sourceCode! !

!SourceMethodConverter methodsFor: 'as yet unclassified' stamp: ''!
shouldShout

	^ true.! !

AbstractMethodConverter subclass: #TimeStampMethodConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MethodConverters'!

!TimeStampMethodConverter commentStamp: '<historical>' prior: 0!
A TimeStampMessageConverter is a wrapper wich display the timestamp of the provided message!

!TimeStampMethodConverter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/16/2012 05:22'!
internalGetText
	| list |
	list := method stamp subStrings.
	list ifEmpty: [ ^ 'No information available' ].
	
	^ String streamContents:[ :s |
			s << 'Last Modification :' << Character cr.
			s << Character tab << 'date:' << Character tab << (list allButFirst joinUsing: ' ') asTimeStamp << Character cr.
 			s << Character tab << 'by:' << Character tab << Character tab << list first ]! !
